from __future__ import absolute_import
from ufl.algorithms import MultiFunction


class _UFLRank(MultiFunction):
    def __call__(self, expr):
        return len(MultiFunction.__call__(self, expr))

    def expr(self, o):
        return set(a for op in o.ufl_operands for a in MultiFunction.__call__(self, op))

    def argument(self, o):
        return (o.number(),)


def ufl_rank(o):
    return _UFLRank()(o)
